using System;
using System.Reflection;
using AppDomainTest; 
// compile: csc /r:appdtestclass.dll appdtestclient.cs
public class AppDomainClient
{
  static void Main()
  {
      AppDomain currentAppDomain;
      currentAppDomain = AppDomain.CurrentDomain;
      RemoteClass rc;
       // rc= new RemoteClass();
       // rc.ShowDomain();
      // (1) Create instance of RemoteClass that resides in assembly appdtestclass
      rc = (RemoteClass)currentAppDomain.CreateInstanceAndUnwrap("appdtestclass",
       	    "AppDomainTest.RemoteClass");
      // (2) Execute method on class in other domain 	    
      rc.ShowDomain();  
      // (3) Show assemblies in this appdomain
      Assembly[] currAssemblies = currentAppDomain.GetAssemblies();
      ShowAssemblies (currAssemblies);
       
      // (4) Create a new AppDomain
      AppDomain myAppDomain = AppDomain.CreateDomain("New Domain");
      rc =(RemoteClass)myAppDomain.CreateInstanceAndUnwrap("appdtestclass", 
              "AppDomainTest.RemoteClass");
      rc.ShowDomain();
      // (5) Show assemblies in new appdomain
      currAssemblies = myAppDomain.GetAssemblies();
      ShowAssemblies(currAssemblies);
      //
      Console.Write("Thread"+System.Threading.Thread.GetDomain().FriendlyName);
      //
      AppDomain.Unload(myAppDomain);
       
  }
     
     private static void ShowAssemblies(Assembly[] currAssemblies)
     {
        foreach(Assembly a in currAssemblies) 
        {
           	Console.WriteLine(" Assembly Name: {0}",a.GetName().Name);
        }
     }
 }