using System;
using System.Text;  
using System.Threading;
using System.IO;
// special namespaces required. Compression only in 2.0
using System.IO.Compression;
using System.Runtime.Remoting.Messaging;
// Deomonstrate Asynchronous IO Compression
public class Async
{   
	// Variables with class scope
	Byte[] buffer;
	FileStream infile;			
	// Compress a specified file using GZip compression
	public void Compress_File(string fileName)
	{
		bool useAsync = true;  // sepecifies asynchronous I/O 
		infile = new FileStream(fileName, FileMode.Open, 
		  FileAccess.Read, FileShare.Read, 2000, useAsync);
		buffer = new byte[infile.Length];
		int ln = buffer.Length;
		// Read file into buffer and let callback method handle compression
		IAsyncResult ar = infile.BeginRead(buffer, 0, ln,
		  new AsyncCallback(Zip_Completed), fileName);
		Thread.Sleep(500);  // delay allows other thread to complete		
	}
	// Callback method that compresses raw data and stores in file.
	private void Zip_Completed(IAsyncResult asResult)
	{
	    // retrieve file name from state object
		string filename = (string)asResult.AsyncState;  
		infile.EndRead(asResult);   // wrapup asynchronous read
		infile.Close();
		// Memory stream will hold compressed data
		MemoryStream ms = new MemoryStream();		
		GZipStream zipStream = new GZipStream(ms, CompressionMode.Compress, true);
		// write raw data in compressed form to memory stream  
		zipStream.Write(buffer, 0, buffer.Length);
		zipStream.Close();
		// store compressed data in a file
		FileStream fs = new FileStream(filename+".gz", 
		  FileMode.OpenOrCreate, FileAccess.Write, FileShare.Read);
		byte[] compressedData = ms.ToArray();
		fs.Write(compressedData, 0, compressedData.Length);
		fs.Close();		
		Console.WriteLine(filename+".gz created.");
	}
}
public class ConsoleApp
{
    public static void Main()
    {
		Async a = new Async();
		a.Compress_File("kublakhan.txt");
	}	
}