using System;
using System.Text;  
using System.Threading;
// Deomonstrate Asynchronous delegate (Listing 13-1)
public class Async
{   
	private delegate decimal bmiDelegate(decimal ht, decimal wt);
    public static void Main()
    {
		
		decimal ht_in = 72;
		decimal wt_lbs=168;
		// (1) Invoke delegate asynchronously
		bmiDelegate bd= new bmiDelegate(CalcBMI);
		IAsyncResult asRes= bd.BeginInvoke(ht_in, wt_lbs,null,null);
		int numPolls=0;
		while(!asRes.IsCompleted)
		{
			// (2) Wait 20 milliseconds for method to signal completion
			asRes.AsyncWaitHandle.WaitOne(20,false); 
			numPolls +=1;
		}
		// (3) Get result now that asynchronous method has finished
		decimal myBMI = bd.EndInvoke(asRes);
		Console.WriteLine("Polls: {0}  BMI: {1:##.00}", numPolls, myBMI);	       
	}	
			
	// Calculate BMI
	private static decimal CalcBMI(decimal ht, decimal wt)
	{
		Thread.Sleep(200);       // Simulate a delay of 200 ms
		Console.WriteLine("Thread:{0}", Thread.CurrentThread.GetHashCode());
		return((wt * 703 *10/(ht*ht))/10);
	}
}