// caoimageclient.cs  (.exe)
using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Collections;
using System.Drawing;
using System.IO;
namespace SimpleImageClient
{
   class ImageClient
   {     
      static void Main(string[] args)
      {          
         // (1) Register channel for TCP/Binary
         TcpChannel c = new TcpChannel();
         ChannelServices.RegisterChannel(c);
         // (2) Register remote type for CAO
         Type ServerType = typeof(ImageServer);
         RemotingConfiguration.RegisterActivatedClientType(
           ServerType,
           "tcp://localhost:3201");  
		 ImageServer imgMgr=null;           
         bool serverOK=true;    // indicates whether server is up
         // (3) Create instance of remote object
         try{
             imgMgr = new ImageServer();
         } catch (Exception ex) {        
             Console.WriteLine(ex.Message);
             serverOK=false;
         }
         if(serverOK)
		 {         
 			 string oper="";
           	 while(oper !="Q") 
	 	  	 {	
	             Console.WriteLine("(L)ist files,(R)etrieve,(Q)uit");
	             oper= Console.ReadLine();
	             oper = oper.ToUpper();
	          	 if(oper=="R"){
	             Console.WriteLine("Enter image name to retrieve:");
	             string fname= Console.ReadLine();
		         // Exception is handled if image cannot be found.
	             try 
				 {
	              	// Request image from server
                 	byte[] image = imgMgr.GetMovieImage(fname);
                 	MemoryStream memStream = new MemoryStream(image); 
	              	Console.WriteLine("Image Size: {0}", memStream.Length);
			  	    // Convert memory stream to a Bitmap object
	                Bitmap bm = new Bitmap(memStream); 
	                // Save image on local system
	                bm.Save("c:\\cs\\"+fname, System.Drawing.Imaging.ImageFormat.Jpeg);
	             } catch (Exception ex) 
	             { Console.WriteLine(ex.Message); }
	         }
	         else 
	         { 
	             if (oper=="L")	// List image file names
     			 { 
      				 try
       				 {	  
	               		 ArrayList images = imgMgr.GetFiles();  
	               		 for (int i=0;i<images.Count;i++)
	               		 {
	      	    			 Console.WriteLine(images[i]);
	               		 }
        		 		 } catch (Exception ex) 
        		 		 { Console.WriteLine(ex.Message); }
	           		 }
 	         	}    
	        }   // while  
     	 }   // serverok             
      }   // Main  
   }    // class
}    // namespace
