using System;
using System.Windows.Forms;
using System.Drawing;
// Displays custom listbox, combox, and checkedlistbox
class MyWinApp
{
  	static void Main() 
  	{
  		// Create form and invoke it
  		Form mainForm = new SimpleForm();
  		Application.Run(mainForm);  
  	}
}
// User Form derived from base class Form
class SimpleForm:Form
{
 	public ListBox lstArtists;
 	public ComboBox cbArtists;
 	public SimpleForm() 
 	{
		this.Text = "Custom ListBox";	 		
   		lstArtists = new ListBox();
		lstArtists.Location= new Point(150,20);
		lstArtists.DrawMode = DrawMode.OwnerDrawFixed;
		lstArtists.ItemHeight = 16;  // Height (pixels) of item
		// Register event handler to perform custom drawing
		lstArtists.DrawItem += new DrawItemEventHandler(DrawList);
		lstArtists.Items.Add
			(new Artist("1832", "1883", "Edouard", "Manet","Fr" ));
		lstArtists.Items.Add
			(new Artist("1840", "1926", "Claude", "Monet","Fr"));
		lstArtists.Items.Add
			(new Artist("1606", "1669", "Von Rijn", "Rembrandt","Ne"));
		lstArtists.Items.Add
			(new Artist("1445", "1510", "Sandro", "Botticelli","It"));
		this.Controls.Add(lstArtists); 
     
        // checkedlistbox 
		CheckedListBox clb = new CheckedListBox();
		clb.Location= new Point(20,20);
		clb.Items.Add
				(new Artist("1832", "1883", "Edouard", "Manet","Fr" ));
		clb.Items.Add
				(new Artist("1840", "1926", "Claude", "Monet","Fr"));
				this.Controls.Add(clb);
				clb.CheckOnClick=true;  
				
	    // combobox
		cbArtists = new ComboBox();
		cbArtists.Location= new Point(20,160);  
		cbArtists.Size = new System.Drawing.Size(120, 21);
		cbArtists.MaxDropDownItems= 4;
		cbArtists.DropDownWidth = 140;
		cbArtists.Items.Add
				(new Artist("1832", "1883", "Edouard", "Manet","Fr" ));
		cbArtists.Items.Add
			(new Artist("1840", "1926", "Claude", "Monet","Fr"));
		cbArtists.Items.Add
			(new Artist("1606", "1669", "Von Rijn", "Rembrandt","Ne"));
		cbArtists.Items.Add
			(new Artist("1445", "1510", "Sandro", "Botticelli","It"));

		this.Controls.Add(cbArtists);
        
    }
  
    private void DrawList(object sender, DrawItemEventArgs e)
    {
	    // Draw ListBox Items
	    string ctry;
	    Rectangle rect = e.Bounds;
	    Artist a = lstArtists.Items[e.Index] as Artist;
 	    string artistName = a.ToString();
	    if ( (e.State & DrawItemState.Selected) == DrawItemState.Selected )
	    {
 		   // Highlight item by providing a custom backcolor
		   // e.Graphics.FillRectangle(Brushes.White,rect);
 		   // Draw Black border around the selected item
		 	e.Graphics.DrawRectangle(Pens.Black,rect); 
	    } else 
	    {
		   ctry = a.Country;
		   Brush b;	// object used to define backcolor
		   // Each country will have a different backcolor
		   b= Brushes.LightYellow;		// Netherlands
		   if (ctry == "Fr")  b = Brushes.LightGreen;
		   if (ctry == "It")  b = Brushes.Yellow;
		   e.Graphics.FillRectangle(b,rect); 	
		   e.Graphics.DrawString( 
		   artistName,e.Font,Brushes.Black,rect);
	    }
    }  
}
// Instances of this class will be placed in a ListBox
public class Artist
{
	public string BDate, DDate, Country;
	private string firstname;
	private string lastname;
	public Artist(string birth, string death, string fname,string lname,string ctry)
	{
		BDate = birth;
		DDate = death;
		Country = ctry;
		firstname = fname;
		lastname = lname;
	}
	public override string ToString() {
		return (lastname+" , "+firstname);
	}
	public string GetLName 	{
		get{ return lastname;} 
	}
	public string GetFName 	{
		get{ return firstname;} 
	}	
}