using System;
using System.ComponentModel;
using System.Windows.Forms;
namespace dragndrop
{
	// Drag and Drop example
	// Compile: csc /t:winexe dragndrop.cs
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox lstPlayers;
		private System.Windows.Forms.ListBox lstTeamB;
		private System.Windows.Forms.ListBox lstTeamA;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			lstPlayers.MouseDown += new MouseEventHandler(Players_MouseDown);
			lstTeamA.DragEnter += new DragEventHandler(TeamA_DragEnter);
			lstTeamA.DragDrop += new DragEventHandler(TeamA_Drop);		
		}

		// Clean up any resources being used.
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			this.lstPlayers = new System.Windows.Forms.ListBox();
			this.lstTeamB = new System.Windows.Forms.ListBox();
			this.lstTeamA = new System.Windows.Forms.ListBox();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();			
			this.label3 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// lstPlayers
			// 
			this.lstPlayers.Location = new System.Drawing.Point(136, 40);
			this.lstPlayers.Name = "lstPlayers";
			this.lstPlayers.Size = new System.Drawing.Size(96, 121);
			this.lstPlayers.TabIndex = 0;
			// 
			// lstTeamB -- Not implemented
			// 
			this.lstTeamB.AllowDrop = true;
			this.lstTeamB.Location = new System.Drawing.Point(16, 188);
			this.lstTeamB.Name = "lstTeamB";
			this.lstTeamB.Size = new System.Drawing.Size(80, 56);
			this.lstTeamB.TabIndex = 1;
			// 
			// lstTeamA
			// 
			this.lstTeamA.AllowDrop = true;
			this.lstTeamA.Location = new System.Drawing.Point(16, 40);
			this.lstTeamA.Name = "lstTeamA";
			this.lstTeamA.Size = new System.Drawing.Size(80, 108);
			this.lstTeamA.TabIndex = 2;
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(160, 240);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(80, 20);
			this.textBox1.TabIndex = 3;
			this.textBox1.Text = "textBox1";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(136, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(112, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "Available Players";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(48, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "Team A";	
            // 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 170);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(48, 16);
			this.label3.TabIndex = 5;
			this.label3.Text = "Team B";			
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(480, 273);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {																		  
																		  this.label2,
																		  this.label1,
																		  this.label3,
																		  this.lstTeamA,
																		  this.lstTeamB,
																		  this.lstPlayers});
			this.Name = "Form1";
			this.Text = "Drag and Drop Example";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);
			this.Width= 320;

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{			 
			this.lstPlayers.Items.Add("William Smith");
			this.lstPlayers.Items.Add("John Hurley");
			this.lstPlayers.Items.Add("Samuel Taylor");
			this.lstPlayers.Items.Add("Ben Wright");
			this.lstPlayers.Items.Add("Joe Horlen");
			this.lstPlayers.Items.Add("Jim Landis");
			this.lstPlayers.Items.Add("Sam Esposito");
			this.lstPlayers.Items.Add("Al Smith");
			this.lstPlayers.Items.Add("Billy Pierce");
			this.lstPlayers.Items.Add("Dick Donavon");
            this.lstPlayers.Items.Add("Turk Lown");
		}


		
		private void Players_MouseDown(object sender, MouseEventArgs e)
		{
			if ( lstPlayers.SelectedIndex>=0) 
			//if (e.Button == MouseButtons.Right && lstPlayers.SelectedIndex>=0) 
			{
				string players = "";
				DragDropEffects effect;
				players = lstPlayers.Items[lstPlayers.SelectedIndex].ToString();
				if(players != "") 
				{
					effect = lstPlayers.DoDragDrop(players,DragDropEffects.Move | DragDropEffects.Copy);
					if (effect == DragDropEffects.Move) 
					{
						int ndx = lstPlayers.SelectedIndex;
						lstPlayers.Items.RemoveAt(ndx);
					}
				}
				
			}
		}

		[FlagsAttribute]
			enum KeyPushed
		{
			LeftMouse = 1,
			CtrlKey = 8,
		}
		private void TeamA_DragEnter(object sender, DragEventArgs e)
		{
			KeyPushed kp = (KeyPushed) e.KeyState;
			int keyState = e.KeyState;
			//if (e.Data.GetDataPresent(typeof(int)))
			if (e.Data.GetDataPresent(typeof(string)))
			{	
				if ( (kp & KeyPushed.LeftMouse) == KeyPushed.LeftMouse) 
					//if ( keyState == 1 || keyState == 9)
				{ 
					if ((kp & KeyPushed.CtrlKey) == KeyPushed.CtrlKey)
						//if (keyState == 9)
					{ e.Effect = DragDropEffects.Copy;}
					else
					{ e.Effect = DragDropEffects.Move;}
				} 
				else 
				{
					e.Effect= DragDropEffects.None;
				}
			}else{
				e.Effect = DragDropEffects.None;
			}			 
		}
		private void TeamA_Drop(object sender, DragEventArgs e)
		{
			MessageBox.Show(e.Effect.ToString());
			lstTeamA.Items.Add( (string) e.Data.GetData(DataFormats.Text) );

		}
	}  // Form1	
	
}
