using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Text;
namespace listview
{
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.ListView listView1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.ComponentModel.Container components = null;
		public Form1()
		{
			InitializeComponent();
			CreateMyListView();
			listView1.SelectedIndexChanged += new EventHandler(lv_IndexChanged);
			// Perform sorting when column clicked
			this.listView1.ColumnClick += new ColumnClickEventHandler(ColumnClick);
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(262, 248);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(66, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "Large Icon";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(16, 208);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(216, 56);
			this.textBox1.TabIndex = 1;
			this.textBox1.Text = " ";
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(262, 216);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(66, 24);
			this.button2.TabIndex = 2;
			this.button2.Text = "Small Icon";
			this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(262, 184);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(66, 24);
			this.button3.TabIndex = 3;
			this.button3.Text = "Details";
			this.button3.Click += new System.EventHandler(this.button3_Click);


			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(344, 273);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button2,
																		  this.textBox1,
																		  this.button3,
																		  this.button1});
			this.Name = "Form1";
			this.Text = " Artists";
			//this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);
		}
		#endregion

		// The main entry point for the application.
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		void CreateMyListView()
		{
			// (1) Create a new ListView control.
			listView1 = new ListView();		
			listView1.Bounds = new Rectangle(new Point(10,10), new Size(300, 170));
			listView1.Name = "listView1";
			// Set the view to show details.
			 listView1.View = View.Details;
			// Allow the user to edit item text.
			listView1.LabelEdit = true;
			// Allow the user to rearrange columns.
			listView1.AllowColumnReorder = true;
			// Select the item and subitems when selection is made.
			listView1.FullRowSelect = true;
			// Display grid lines.
			listView1.GridLines = true;
			// Sort the items in the list in ascending order.
			listView1.Sorting = SortOrder.Ascending;
                
			// (2) Create five items and three sets of subitems for each item.
			ListViewItem item1 = new ListViewItem("Manet",2);
			item1.SubItems.Add("1832");
			item1.SubItems.Add("1883");
			item1.SubItems.Add("France");
			// Alternate way of adding item
			ListViewItem item2 = new ListViewItem(new string[] {"Monet","1840","1926","France"}, 3);
			ListViewItem item3 = new ListViewItem("Rembrandt",4);
			item3.SubItems.Add("1606");
			item3.SubItems.Add("1669");
			item3.SubItems.Add("Netherlands");
			ListViewItem item4 = new ListViewItem("Cezanne",1);
			item4.SubItems.Add("1839");
			item4.SubItems.Add("1906");
			item4.SubItems.Add("France");
			ListViewItem item5 = new ListViewItem("Botticelli",0);
			item5.SubItems.Add("1445");
			item5.SubItems.Add("1510");
			item5.SubItems.Add("Italy");
			// Create columns for the items and subitems.
			listView1.Columns.Add("Artist", -2, HorizontalAlignment.Left);
			listView1.Columns.Add("Born", -2, HorizontalAlignment.Left);
			listView1.Columns.Add("Died", -2, HorizontalAlignment.Left);
			listView1.Columns.Add("Country", -2, HorizontalAlignment.Left);
			//Add the items to the ListView.
			listView1.Items.AddRange(new ListViewItem[]{item1,item2,item3,item4,item5});

			// (3) Create two ImageList objects.
			ImageList imageListSmall = new ImageList();
			ImageList imageListLarge = new ImageList();
			imageListLarge.ImageSize = new Size(30,30);

			// (4) Initialize the ImageList objects with bitmaps.
			imageListSmall.Images.Add(Bitmap.FromFile("C:\\botti.jpg"));
			imageListSmall.Images.Add(Bitmap.FromFile("C:\\cezanne.jpg"));
			imageListSmall.Images.Add(Bitmap.FromFile("C:\\manet.jpg"));
			imageListSmall.Images.Add(Bitmap.FromFile("C:\\monet.jpg"));
			imageListSmall.Images.Add(Bitmap.FromFile("C:\\rembrandt.jpg"));

			imageListLarge.Images.Add(Bitmap.FromFile("C:\\botti.jpg"));
			imageListLarge.Images.Add(Bitmap.FromFile("C:\\cezanne.jpg"));
			imageListLarge.Images.Add(Bitmap.FromFile("C:\\manet.jpg"));
			imageListLarge.Images.Add(Bitmap.FromFile("C:\\monet.jpg"));
			imageListLarge.Images.Add(Bitmap.FromFile("C:\\rembrandt.jpg"));

			// (5) Assign the ImageList objects to the ListView.
			listView1.LargeImageList = imageListLarge;
			listView1.SmallImageList = imageListSmall;

			// Add the ListView to the control collection.
			this.Controls.Add(listView1);
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
		    // display as large icons
			ListView lv = listView1;
			lv.View = View.LargeIcon;
		}
		
		// ColumnClick event handler.
		private void ColumnClick(object o, ColumnClickEventArgs e)
		{
			// Set the ListViewItemSorter property to a new ListViewItemComparer 
			// object. Setting this property immediately sorts the 
			// ListView using the ListViewItemComparer object.
			this.listView1.ListViewItemSorter = new ListViewItemComparer(e.Column);
		}

		// Implements the manual sorting of items by columns.
		class ListViewItemComparer : IComparer
		{
			private int col;
			public ListViewItemComparer()
			{
				col = 0;
			}
			public ListViewItemComparer(int column)
			{
				col = column;
			}
			public int Compare(object x, object y)
			{
				return String.Compare(((ListViewItem)x).SubItems[col].Text, ((ListViewItem)y).SubItems[col].Text);
			}
		}


		private void lv_IndexChanged(object sender, System.EventArgs e)
		{
			// display artist name in text box when new artist selected
			string ItemText = listView1.FocusedItem.Text;
			textBox1.Text= ItemText;
		}
		
		private void button2_Click(object sender, System.EventArgs e)
		{
		    // Display as small icons
		    ListView lv = listView1;
			lv.View = View.SmallIcon;		 
		}
		private void button3_Click(object sender, System.EventArgs e)
		{
			// Display as small icons
			ListView lv = listView1;
			lv.View = View.Details;		 
		}
 
	}
}
