using System;
using System.Threading;
using System.IO;
// Demonstrates the need to synchronize resource usage
// Run several times from console to show synchronization problem.
public class MyApp
{  
    public static void Main()
    { 
        CallerClass cc = new CallerClass();     
        Thread worker1 = new Thread(new ThreadStart(cc.CallUpdate));     
        Thread worker2 = new Thread(new ThreadStart(cc.CallUpdate));          
        worker1.Start();         
        worker2.Start();  
    }
}
public class CallerClass
{
    WorkClass wc;
    public CallerClass()
    {
        wc= new WorkClass();  // create object to update log
    }
    public void CallUpdate()
    {     
        wc.UpdateLog();  
    }
}
public class WorkClass
{  
 	public void UpdateLog()
 	{   
        // Open stream for reading and writing           
        try
        {  
			FileStream fs = new FileStream(@"c:\log.txt",FileMode.OpenOrCreate, 
      	       FileAccess.ReadWrite, FileShare.ReadWrite); 
        	StreamReader sr = new StreamReader(fs);
       		// Read current counter
       		string ctr = sr.ReadLine();
       		if(ctr==null) ctr="0";
       		int oldCt = int.Parse(ctr) + 1;       
 			// if the thread's time slice ends here, the counter  
 			// is not updated.    
      		fs.Seek(0,SeekOrigin.Begin);
      		StreamWriter sw= new StreamWriter(fs);
       		sw.WriteLine(oldCt.ToString());
      		Console.WriteLine(oldCt);
       		sw.Close();
      		sr.Close();
      	}  catch(Exception ex)
		{
  		  Console.WriteLine(ex.Message);
		}
    }    
}	  // WorkClass
