using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace textsearch
{
	// compile: csc /t:library /r:texthelper.dll searchfrom.cs
	public class searchFrom : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtSearch;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnFind;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton radUp;
		private System.Windows.Forms.RadioButton radDown;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.CheckBox chkCase;
		// Required designer variable.
		private System.ComponentModel.Container components = null;

		public searchFrom()
		{
			InitializeComponent();

			this.Deactivate += new System.EventHandler(FormDeactivate);
			this.Activated += new System.EventHandler(FormActivate);
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			this.txtSearch = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.btnFind = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.radDown = new System.Windows.Forms.RadioButton();
			this.radUp = new System.Windows.Forms.RadioButton();
			this.btnClose = new System.Windows.Forms.Button();
			this.chkCase = new System.Windows.Forms.CheckBox();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// txtSearch
			// 
			this.txtSearch.Location = new System.Drawing.Point(80, 16);
			this.txtSearch.Name = "txtSearch";
			this.txtSearch.Size = new System.Drawing.Size(104, 20);
			this.txtSearch.TabIndex = 0;
			this.txtSearch.Text = "";
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Search For:";
			// 
			// btnFind
			// 
			this.btnFind.Location = new System.Drawing.Point(200, 16);
			this.btnFind.Name = "btnFind";
			this.btnFind.Size = new System.Drawing.Size(72, 24);
			this.btnFind.TabIndex = 2;
			this.btnFind.Text = "Find Next";
			this.btnFind.Click += new System.EventHandler(this.btnFind_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.radDown,
																					this.radUp});
			this.groupBox1.Location = new System.Drawing.Point(112, 56);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(72, 64);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Direction";
			// 
			// radDown
			// 
			this.radDown.Checked = true;
			this.radDown.Location = new System.Drawing.Point(8, 40);
			this.radDown.Name = "radDown";
			this.radDown.Size = new System.Drawing.Size(56, 16);
			this.radDown.TabIndex = 1;
			this.radDown.TabStop = true;
			this.radDown.Text = "Down";
			// 
			// radUp
			// 
			this.radUp.Location = new System.Drawing.Point(8, 16);
			this.radUp.Name = "radUp";
			this.radUp.Size = new System.Drawing.Size(48, 16);
			this.radUp.TabIndex = 0;
			this.radUp.Text = "Up";
			// 
			// btnClose
			// 
			this.btnClose.Location = new System.Drawing.Point(200, 96);
			this.btnClose.Name = "btnClose";
			this.btnClose.Size = new System.Drawing.Size(72, 24);
			this.btnClose.TabIndex = 4;
			this.btnClose.Text = "Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// chkCase
			// 
			this.chkCase.Location = new System.Drawing.Point(8, 48);
			this.chkCase.Name = "chkCase";
			this.chkCase.TabIndex = 5;
			this.chkCase.Text = "Case Sensitive";
			// 
			// searchFrom
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(280, 125);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.chkCase,
																		  this.btnClose,
																		  this.groupBox1,
																		  this.btnFind,
																		  this.label1,
																		  this.txtSearch});
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "searchFrom";
			this.Text = "Search Form";
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		public String SearchPhrase
		{
			//get {return txtSearch.Text;}
			set { txtSearch.Text = value;}
		}

		private void FormDeactivate(object sender, EventArgs e)
		{
			this.Opacity = .5;
		}
		private void FormActivate(object sender, EventArgs e)
		{
			this.Opacity = 1.0;
		}
		
		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btnFind_Click(object sender, System.EventArgs e)
		{
			int ib;
			string myBuff = TextHelper.myText.Text; // copy of text box
			string searchText= this.txtSearch.Text;
			int ln = searchText.Length;       // length of search string
            if (ln>0) 
			{
				//int selStart = Form1.myText.SelectionStart;
				//if (selStart >= Form1.myText.Text.Length) 
				int selStart = TextHelper.myText.SelectionStart;
				if (selStart >= TextHelper.myText.Text.Length) 
				{	
					ib = 0; 
				} else {
					ib = selStart + ln;
				}
				if (!this.chkCase.Checked) // Perform case-insensitive search
				{
					searchText = searchText.ToUpper();
					myBuff = myBuff.ToUpper();
				}
				if (this.radDown.Checked)ib = myBuff.IndexOf(searchText,ib);
				if (this.radUp.Checked && ib>ln-1)  ib = myBuff.LastIndexOf(searchText,ib-2,ib-1);
				if (ib >= 0) 
				{
					//Form1.myText.SelectionStart = ib;
					//Form1.myText.SelectionLength = this.txtSearch.Text.Length;
				    TextHelper.myText.SelectionStart = ib;
					TextHelper.myText.SelectionLength = this.txtSearch.Text.Length;

				}
			}
		}

	}
}