using System;
using System.Drawing;	
using System.Drawing.Printing;
using System.Windows.Forms;
// Use this as a template for Printing
class PrintApp
{
  static void Main() 
  {
     // Create form and invoke it
     Application.Run(new PrintForm());  
  }
}
 
class PrintForm:Form
{
 	// constructor
 	public PrintForm() 
 	{
	 	Button btnPrint = new Button();
	 	btnPrint.Text="Print";
	 	btnPrint.Location= new Point(100,60);
		this.Controls.Add(btnPrint);
		btnPrint.Click += new EventHandler(btnPrint_Click);	
		this.Text="Printing Example";
		this.Height= 200;
	}	
	
	// Respond to button click
 	private void btnPrint_Click(object sender, System.EventArgs e)
	{ 
		PrintReport();
	}
	// Set up overhead for printing
 	private void PrintReport() 
	{
		// (1) Create PrintDocument object
		PrintDocument pd = new PrintDocument();
		// (2) Create PrintDialog
		PrintDialog pDialog = new PrintDialog();
		pDialog.Document = pd;
		// (3) Create PrintPreviewDialog
		PrintPreviewDialog prevDialog = new PrintPreviewDialog();
		prevDialog.Document = pd;
		// (4) Tie event handler to PrintPage event
		pd.PrintPage += new PrintPageEventHandler(Inven_Report);
		// (5) Display Print Dialog and print if OK received.
		if (pDialog.ShowDialog()== DialogResult.OK) 
		{
			pd.Print(); // Invoke PrintPage event
		}
	 }
	 private void Inven_Report(object sender, PrintPageEventArgs e)
	 {
		Graphics g = e.Graphics;
		Font myFont = new Font("Arial",10);
		g.DrawString("Sample Output",myFont,Brushes.Black,10,10);
		myFont.Dispose();
	 }
}