using System;
using System.Collections;
using System.Threading;
using System.IO;
using System.Drawing;
namespace ThreadExample
{
	class SimpleClient
	{     
		static void Main(string[] args)
		{
		   Threader t=new Threader();
		}              
	}   
    class Threader
    {
		ImageServer server;
		public Threader()
		{
			server= new ImageServer(); 
			StartThreader();    
		}
		public void StartThreader()
		{
			// Create 7 threads to retrieve images
			for (int i=0;i<7;i++)
			{    
				//(1) Create Delegate
				ThreadStart threadStart = new ThreadStart(FetchImage);
				//(2) Spawn thread
				Thread workerThread = new Thread(threadStart);
				//(3) Set two priorities for comparison testing 
				if( i % 2 == 1)
					 workerThread.Priority = ThreadPriority.Lowest;
				 else
					 workerThread.Priority = ThreadPriority.AboveNormal;
				//(4) Launch Thread
				workerThread.Start();         
			}
		}
		public void FetchImage()
		{
			// identify thread
			Console.WriteLine("Thread"+Thread.CurrentThread.GetHashCode());
			string[] posters =  {"afi1.gif","afi2.gif","afi6.gif", "afi7.gif","afi8.gif"};
			// Retrieve 5 images on each thread
			// ImageServer server= new ImageServer();
			Monitor.Enter(server);
			try
			{
			    for (int i=0;i<5;i++)
			    {
				   byte[] imgArray = server.GetMovieImage(posters[i], 
					  Thread.CurrentThread.GetHashCode());
				   MemoryStream ms = new MemoryStream(imgArray);
				   Bitmap bmp = new Bitmap(ms);
			    }
			}
			catch (Exception ex)
			{  Console.WriteLine(ex.Message); }
			Monitor.Exit(server);
		}	// FetchImage
    }    // Threader
  
  
	public class ImageServer
	{  
		public  byte[] GetMovieImage(string imageName, int threadNum)
		{
			// Returns requested image to client as a series o bytes, 
			// and displays thread number of calling thread.
			int imgByte;
			imageName= "c:\\images\\"+imageName;
			// If file not available exception is thrown and caught by client
			FileStream s = File.OpenRead(imageName);
			MemoryStream ms = new MemoryStream();
			while((imgByte =s.ReadByte())!=-1)
			{
			    ms.WriteByte(((byte)imgByte));
			}
			// Display order in which threads are processed
			Console.WriteLine("Thread: {0}",threadNum);  
			return ms.ToArray();            
		}
	}
     
 }	  // Simpleclient