using System;
using System.Windows.Forms;
using System.Drawing;
using System.Collections;
using System.Reflection;
class MyWinApp
{
  static void Main() 
  {
     // Create form and invoke it
     Application.Run(new SimpleForm());  
  }
}
// User Form derived from base class Form
class SimpleForm:Form
{
 public TreeView tvEnum;
 public ListView lView;
 public TextBox AssemName;
 public Button BtnShow;
 public SimpleForm() 
 {
	 this.Text = "TreeView Project";
	 this.Size= new Size(380,220);

	 tvEnum= new TreeView();
	 tvEnum.Location = new Point(10,10);
	 tvEnum.Size= new Size(180,120);
	 this.Controls.Add(tvEnum);
	 tvEnum.AfterSelect += new TreeViewEventHandler(tvEnum_AfterSelect);
	 //
	 BtnShow = new Button();
	 BtnShow.Text="Select";
	 BtnShow.Location= new Point(120,140);
	 BtnShow.TabIndex=2;
	 this.Controls.Add(BtnShow);
	 BtnShow.Click += new EventHandler(ShowAssembly);
	 //
	 AssemName = new TextBox();
	 AssemName.Location= new Point(10,140);
	 AssemName.Size= new Size(100,10);
	 AssemName.TabIndex = 1;
	 this.Controls.Add(AssemName);   
	 //
	 lView = new ListView();
	 lView.Location = new Point(200,10);
	 lView.Size= new Size(150,120);
	 this.Controls.Add(lView);
	 lView.View = View.List;
	 //   
 }  
   
 private void ShowAssembly(object sender, EventArgs e)
 {
     GetEnums();
 }
 private void GetEnums()
 {
   lView.Items.Clear();
   try
   {
     TreeNode tNode=null;
     Assembly refAssembly ;
     Hashtable ht= new Hashtable();  // keep track of namespaces
     string assem = AssemName.Text;  // Get assembly in text box
     tvEnum.Nodes.Clear();
     // load assembly to be probed
     refAssembly = Assembly.Load(assem);
     foreach (Type t in refAssembly.GetTypes())
     {
       // Get types that inherit from System.Enum
       if(t.BaseType!=null && t.BaseType.FullName=="System.Enum")
       {
          string myEnum  = t.FullName;
	      string  nSpace = myEnum.Substring(0,myEnum.LastIndexOf("."));
	      myEnum= myEnum.Substring(myEnum.LastIndexOf(".")+1) ;
	      // Determine if namespace in hashtable
	      if( ht.Contains(nSpace))
	      {  
	          // Find parent node  representing this namespace
	          foreach (TreeNode tp in tvEnum.Nodes)
	          {
	              if(tp.Text == myEnum) { tNode=tp; break;}
	          }	       
	      } 
	      else
	     {                   
	     	  // Add parent node to display namespace
	     	  tNode = tvEnum.Nodes.Add(nSpace);
	     	  ht.Add(nSpace,nSpace);
	  	 }
	     // Add Child - name of enumeration
	     TreeNode cNode = new TreeNode();
	     cNode.Text= myEnum;
	     cNode.Tag = t;     // Contains specific enumeration
	     tNode.Nodes.Add(cNode);	                     
       }                
    }  // foreach
   } catch (Exception ex)
     {MessageBox.Show(ex.Message);}
 }
  
 private void tvEnum_AfterSelect(Object sender, TreeViewEventArgs e)
 {
    TreeNode tn = e.Node;   // Node selected     
    if(tn.Parent !=null)    // Exclude parent nodes
    {
       lView.Items.Clear();
       Type cNode = (Type) tn.Tag;               
       foreach (MemberInfo mi in cNode.GetMembers())
       {               	   
	 	 if(mi.MemberType==MemberTypes.Field && mi.Name != "value__" )
         {	     
	         lView.Items.Add(mi.Name);
	     }               
       }           
    }       
  }   
   
} // end of SimpleForm