using System;
using System.Xml;
using System.Xml.XPath;
using System.IO;
using System.Xml.Xsl;
using System.Text;
// Read nodes from XML file
public class Transform
{
	public static void Main()
	{           
		ListMovies();
	}
    // .NET Framework 1.1 version
	private static void ListMovies()
	{
	 	XmlDocument doc = new XmlDocument();
	 	doc.Load("\\oscarwinners.xml");
	 	XmlNodeReader noderdr = new XmlNodeReader(doc);
	 	while (noderdr.Read())
	 	{
             if(noderdr.NodeType==XmlNodeType.Element){
              if (noderdr.Name == "movie_Title")
              {
                 noderdr.Read();  // next node is text for title
                 Console.Write(noderdr.Value);    // Movie Title
              }
              if (noderdr.Name == "movie_Year")
              {
                 noderdr.Read();  // next node is text for year
                 Console.WriteLine(noderdr.Value); // year                         
              }
           }	 	
	 	
	 	}
	 }
	
	/* .NET Framework 2.0 version
	
    private static void ListMovies()
    {
       // (1) Specify XML file to be loaded as a DOM
       XmlDocument doc = new XmlDocument();
       doc.Load("\\oscarwinners.xml");
   	   // (2) Settings for use with XmlNodeReader object
       XmlReaderSettings settings = new XmlReaderSettings();
       settings.ConformanceLevel = ConformanceLevel.Fragment;
       settings.IgnoreWhitespace = true;
       settings.IgnoreComments = true;
	   // (3) Create a nodereader object
       XmlNodeReader noderdr = new XmlNodeReader(doc);
	   // (4) Create an XmlReader as a wrapper around node reader
       XmlReader reader = XmlReader.Create(noderdr, settings);            
       while (reader.Read())
       {
           if(reader.NodeType==XmlNodeType.Element){
              if (reader.Name == "movie_Title")
              {
                 reader.Read();  // next node is text for title
                 Console.Write(reader.Value);    // Movie Title
              }
              if (reader.Name == "movie_Year")
              {
                 reader.Read();  // next node is text for year
                 Console.WriteLine(reader.Value); // year                         
              }
           }
	   }
    }
    
    */
 }  