using System;
using System.Xml;
using System.IO;
using System.Text;
// Write XML Document
public class Writer
{
	public static void Main()
	{           
		WriteMovie();
	}
    // .NET Framework 1.1 version 
    private static void WriteMovie()
    {
        string[,] movieList = { { "Annie Hall", "Woody Allen" },
                              { "Lawrence of Arabia", "David Lean" } };
        // (2) Create XmlTextWriter object
        XmlTextWriter writer = new XmlTextWriter(Console.Out);        
 	    writer.WriteStartDocument();
        writer.WriteComment("Output from xmlTextWriter class");
        writer.WriteStartElement("films");
        for (int i = 0; i <= movieList.GetUpperBound(0) ; i++)
        {
          try
          {
              writer.WriteStartElement("movie");
              writer.WriteElementString("Title", movieList[i, 0]);
              writer.WriteElementString("Director", movieList[i, 1]);
              writer.WriteElementString("Movie_ID",i.ToString());
              writer.WriteEndElement();
          }
          catch (Exception ex)
          {
              Console.WriteLine(ex.Message);
          }                 
        }
        writer.WriteEndElement();
        writer.Flush();    // Flush any remaining content to XML stream
        writer.Close();	
	}
	
    /*
    // .NET Framework 2.0 version 
    private static void WriteMovie()
    {
        string[,] movieList = { { "Annie Hall", "Woody Allen" },
                              { "Lawrence of Arabia", "David Lean" } };
        // (1) Define settings to govern writer actions
        XmlWriterSettings settings = new XmlWriterSettings();
        settings.Indent = true;
        settings.IndentChars = ("    ");
        settings.ConformanceLevel = ConformanceLevel.Document;
        settings.CloseOutput = false;
        settings.OmitXmlDeclaration = false;
        // (2) Create XmlWriter object to write to file
        XmlWriter writer = XmlWriter.Create("mymovies.xml", settings);        
 	    writer.WriteStartDocument();
        writer.WriteComment("Output from xmlwriter class");
        writer.WriteStartElement("films");
        for (int i = 0; i <= movieList.GetUpperBound(0) ; i++)
        {
          try
          {
              writer.WriteStartElement("movie");
              writer.WriteElementString("Title", movieList[i, 0]);
              writer.WriteElementString("Director", movieList[i, 1]);
              writer.WriteStartElement("Movie_ID");
              writer.WriteValue(i); // do not have to convert to string
              writer.WriteEndElement();
              writer.WriteEndElement();
          }
          catch (Exception ex)
          {
              Console.WriteLine(ex.Message);
          }                 
        }
        writer.WriteEndElement();
        writer.Flush();    // Flush any remaining content to XML stream
        writer.Close();   	
	}    
	*/
	
	/*
			Output:
				<?xml version="1.0" encoding="utf-8"?>
				<!--Output from xmlwriter class-->
				<films>
					<movie>
						<Title>Annie Hall</Title>
						<Director>Woody Allen</Director>
						<Movie_ID>0</Movie_ID>
					</movie>
					<movie>
						<Title>Lawrence of Arabia</Title>
						<Director>David Lean</Director>
						<Movie_ID>1</Movie_ID>
					</movie>
				</films>	 	 	 
	*/
}  